package com.example.catchTheLetters.service.impl;

import com.example.catchTheLetters.constant.CommonConstant;
import com.example.catchTheLetters.entity.Level;
import com.example.catchTheLetters.service.LevelService;
import com.example.catchTheLetters.utils.R;
import com.github.yulichang.method.mp.Delete;
import com.mongodb.client.result.DeleteResult;
import com.mongodb.client.result.UpdateResult;
import com.mongodb.internal.bulk.DeleteRequest;
import jakarta.annotation.Resource;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.data.mongodb.core.query.Update;
import org.springframework.stereotype.Service;

/**
 * @author 慕华
 * @date 2024/4/10
 * @Version 1.0
 * @description
 */
@Service
public class LevelServiceImpl implements LevelService {
    @Resource
    private MongoTemplate mongoTemplate;

    @Override
    public boolean delete(String id) {
        Level level = new Level();
        level.setId(id);
        DeleteResult deleteRequest = mongoTemplate.remove(level);
        if (deleteRequest.getDeletedCount() > 0) {
            return true;
        } else {
            return false;
        }
    }

    @Override
    public boolean update(Level level) {
        Query query=Query.query(Criteria.where("id").is(level.getId()));
        Update update = new Update();
        update.set("order",level.getOrder());
        update.set("name",level.getName());
        update.set("type",level.getType());
        update.set("timeLimit",level.getTimeLimit());
        update.set("targetScore",level.getTargetScore());
        update.set("words",level.getWords());

        UpdateResult updateResult=mongoTemplate.updateFirst(query, update, Level.class);
        if (updateResult.getModifiedCount() > 0) {
            return true;
        } else {
            return false;
        }
    }
}
